summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorTavian Barnes <tavianator@gmail.com>2009-10-28 20:36:11 -0400
committerTavian Barnes <tavianator@gmail.com>2009-10-28 20:36:11 -0400
commitd79aa8e37baf159dab062999c0d0e84044fd3a4c (patch)
tree7b5b12e15fec4f5b8a38d47ad98f79e1a462fdba
parent6ae9c2de9347a7d9cff2f189050fe4cf0408573e (diff)
downloaddimension-d79aa8e37baf159dab062999c0d0e84044fd3a4c.tar.xz
Split tokenizer.sh into multiple tests.
-rw-r--r--dimension/tokenize.c2
-rw-r--r--tests/dimension/Makefile.am24
-rwxr-xr-xtests/dimension/directives.sh29
-rwxr-xr-xtests/dimension/labels.sh29
-rwxr-xr-xtests/dimension/numeric.sh (renamed from tests/dimension/tokenizer.sh)43
-rwxr-xr-xtests/dimension/punctuation.sh29
-rwxr-xr-xtests/dimension/strings.sh30
7 files changed, 138 insertions, 48 deletions
diff --git a/dimension/tokenize.c b/dimension/tokenize.c
index da190be..83ae0aa 100644
--- a/dimension/tokenize.c
+++ b/dimension/tokenize.c
@@ -447,7 +447,7 @@ dmnsn_tokenize(const char *filename, FILE *file)
}
token.filename = malloc(strlen(filename) + 1);
- strcpy(token.filename, filename);
+ token.filename = strdup(filename);
dmnsn_array_push(tokens, &token);
}
diff --git a/tests/dimension/Makefile.am b/tests/dimension/Makefile.am
index c0ea38e..8bf7550 100644
--- a/tests/dimension/Makefile.am
+++ b/tests/dimension/Makefile.am
@@ -19,13 +19,27 @@
INCLUDES = -I$(top_srcdir)/libdimension
-TESTS = tokenizer.sh
+TESTS = punctuation.sh numeric.sh strings.sh labels.sh directives.sh
TESTS_ENVIRONMENT = top_builddir=$(top_builddir)
-tokenizer.sh:
- cp $(srcdir)/tokenizer.sh .
+punctuation.sh:
+ cp $(srcdir)/punctuation.sh .
-EXTRA_DIST = tokenizer.sh \
+numeric.sh:
+ cp $(srcdir)/numeric.sh .
+
+strings.sh:
+ cp $(srcdir)/strings.sh .
+
+labels.sh:
+ cp $(srcdir)/labels.sh .
+
+directives.sh:
+ cp $(srcdir)/directives.sh .
+
+EXTRA_DIST = $(TESTS) \
punctuation.pov \
numeric.pov \
- labels.pov
+ strings.pov \
+ labels.pov \
+ directives.pov
diff --git a/tests/dimension/directives.sh b/tests/dimension/directives.sh
new file mode 100755
index 0000000..a4114a8
--- /dev/null
+++ b/tests/dimension/directives.sh
@@ -0,0 +1,29 @@
+#!/bin/sh
+
+#########################################################################
+# Copyright (C) 2009 Tavian Barnes <tavianator@gmail.com> #
+# #
+# This file is part of The Dimension Test Suite. #
+# #
+# The Dimension Test Suite is free software; you can redistribute it #
+# and/or modify it under the terms of the GNU General Public License as #
+# published by the Free Software Foundation; either version 3 of the #
+# License, or (at your option) any later version. #
+# #
+# The Dimension Test Suite is distributed in the hope that it will be #
+# useful, but WITHOUT ANY WARRANTY; without even the implied warranty #
+# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU #
+# General Public License for more details. #
+# #
+# You should have received a copy of the GNU General Public License #
+# along with this program. If not, see <http://www.gnu.org/licenses/>. #
+#########################################################################
+
+directives=$(${top_builddir}/dimension/dimension --tokenize ${srcdir}/directives.pov)
+directives_exp='({ \( [ < + - * / , > ] \) } #declare (identifier "x"))';
+
+if [ "$directives" != "$directives_exp" ]; then
+ echo "directives.pov tokenized as \"$directives\"" >&2
+ echo " -- expected \"$directives_exp\"" >&2
+ exit 1
+fi
diff --git a/tests/dimension/labels.sh b/tests/dimension/labels.sh
new file mode 100755
index 0000000..c03aefd
--- /dev/null
+++ b/tests/dimension/labels.sh
@@ -0,0 +1,29 @@
+#!/bin/sh
+
+#########################################################################
+# Copyright (C) 2009 Tavian Barnes <tavianator@gmail.com> #
+# #
+# This file is part of The Dimension Test Suite. #
+# #
+# The Dimension Test Suite is free software; you can redistribute it #
+# and/or modify it under the terms of the GNU General Public License as #
+# published by the Free Software Foundation; either version 3 of the #
+# License, or (at your option) any later version. #
+# #
+# The Dimension Test Suite is distributed in the hope that it will be #
+# useful, but WITHOUT ANY WARRANTY; without even the implied warranty #
+# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU #
+# General Public License for more details. #
+# #
+# You should have received a copy of the GNU General Public License #
+# along with this program. If not, see <http://www.gnu.org/licenses/>. #
+#########################################################################
+
+labels=$(${top_builddir}/dimension/dimension --tokenize ${srcdir}/labels.pov)
+labels_exp='(camera { } sphere { color (identifier "new_identifier") } box { color (identifier "new_identifier") })';
+
+if [ "$labels" != "$labels_exp" ]; then
+ echo "labels.pov tokenized as \"$labels\"" >&2
+ echo " -- expected \"$labels_exp\"" >&2
+ exit 1
+fi
diff --git a/tests/dimension/tokenizer.sh b/tests/dimension/numeric.sh
index 762cced..b64c218 100755
--- a/tests/dimension/tokenizer.sh
+++ b/tests/dimension/numeric.sh
@@ -19,52 +19,11 @@
# along with this program. If not, see <http://www.gnu.org/licenses/>. #
#########################################################################
-exitstatus=0
-
-punctuation=$(${top_builddir}/dimension/dimension --tokenize ${srcdir}/punctuation.pov)
-punctuation_exp='({ \( [ < + - * / , > ] \) })'
-
-if [ "$punctuation" != "$punctuation_exp" ]; then
- echo "punctuation.pov tokenized as \"$punctuation\"" >&2
- echo " -- expected \"$punctuation_exp\"" >&2
- exitstatus=1
-fi
-
numeric=$(${top_builddir}/dimension/dimension --tokenize ${srcdir}/numeric.pov)
numeric_exp='((int "1") (int "123456789") (int "01234567") (int "0x123456789") - (int "0x01") (float ".1") (float "0.1") (float "1.0") (float "0.123456789") - (float "0.123456789") < (int "1") , (float "2.2") , - (float "3.03") >)'
if [ "$numeric" != "$numeric_exp" ]; then
echo "numeric.pov tokenized as \"$numeric\"" >&2
echo " -- expected \"$numeric_exp\"" >&2
- exitstatus=1
-fi
-
-strings=$(${top_builddir}/dimension/dimension --tokenize ${srcdir}/strings.pov)
-strings_exp='((string "This is a string with
-"escape sequences"\"))'
-
-if [ "$strings" != "$strings_exp" ]; then
- echo "strings.pov tokenized as \"$strings\"" >&2
- echo " -- expected \"$strings_exp\"" >&2
- exitstatus=1
+ exit 1
fi
-
-labels=$(${top_builddir}/dimension/dimension --tokenize ${srcdir}/labels.pov)
-labels_exp='(camera { } sphere { color (identifier "new_identifier") } box { color (identifier "new_identifier") })';
-
-if [ "$labels" != "$labels_exp" ]; then
- echo "labels.pov tokenized as \"$labels\"" >&2
- echo " -- expected \"$labels_exp\"" >&2
- exitstatus=1
-fi
-
-directives=$(${top_builddir}/dimension/dimension --tokenize ${srcdir}/directives.pov)
-directives_exp='({ \( [ < + - * / , > ] \) } #declare (identifier "x"))';
-
-if [ "$directives" != "$directives_exp" ]; then
- echo "directives.pov tokenized as \"$directives\"" >&2
- echo " -- expected \"$directives_exp\"" >&2
- exitstatus=1
-fi
-
-exit $exitstatus
diff --git a/tests/dimension/punctuation.sh b/tests/dimension/punctuation.sh
new file mode 100755
index 0000000..5364670
--- /dev/null
+++ b/tests/dimension/punctuation.sh
@@ -0,0 +1,29 @@
+#!/bin/sh
+
+#########################################################################
+# Copyright (C) 2009 Tavian Barnes <tavianator@gmail.com> #
+# #
+# This file is part of The Dimension Test Suite. #
+# #
+# The Dimension Test Suite is free software; you can redistribute it #
+# and/or modify it under the terms of the GNU General Public License as #
+# published by the Free Software Foundation; either version 3 of the #
+# License, or (at your option) any later version. #
+# #
+# The Dimension Test Suite is distributed in the hope that it will be #
+# useful, but WITHOUT ANY WARRANTY; without even the implied warranty #
+# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU #
+# General Public License for more details. #
+# #
+# You should have received a copy of the GNU General Public License #
+# along with this program. If not, see <http://www.gnu.org/licenses/>. #
+#########################################################################
+
+punctuation=$(${top_builddir}/dimension/dimension --tokenize ${srcdir}/punctuation.pov)
+punctuation_exp='({ \( [ < + - * / , > ] \) })'
+
+if [ "$punctuation" != "$punctuation_exp" ]; then
+ echo "punctuation.pov tokenized as \"$punctuation\"" >&2
+ echo " -- expected \"$punctuation_exp\"" >&2
+ exit 1
+fi
diff --git a/tests/dimension/strings.sh b/tests/dimension/strings.sh
new file mode 100755
index 0000000..7557100
--- /dev/null
+++ b/tests/dimension/strings.sh
@@ -0,0 +1,30 @@
+#!/bin/sh
+
+#########################################################################
+# Copyright (C) 2009 Tavian Barnes <tavianator@gmail.com> #
+# #
+# This file is part of The Dimension Test Suite. #
+# #
+# The Dimension Test Suite is free software; you can redistribute it #
+# and/or modify it under the terms of the GNU General Public License as #
+# published by the Free Software Foundation; either version 3 of the #
+# License, or (at your option) any later version. #
+# #
+# The Dimension Test Suite is distributed in the hope that it will be #
+# useful, but WITHOUT ANY WARRANTY; without even the implied warranty #
+# of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU #
+# General Public License for more details. #
+# #
+# You should have received a copy of the GNU General Public License #
+# along with this program. If not, see <http://www.gnu.org/licenses/>. #
+#########################################################################
+
+strings=$(${top_builddir}/dimension/dimension --tokenize ${srcdir}/strings.pov)
+strings_exp='((string "This is a string with
+"escape sequences"\"))'
+
+if [ "$strings" != "$strings_exp" ]; then
+ echo "strings.pov tokenized as \"$strings\"" >&2
+ echo " -- expected \"$strings_exp\"" >&2
+ exit 1
+fi